include (jslib_dirutils);
include (jslib_prefs);

function MozImagePrefs() 
{
  this.prefs = new Prefs();
  this.load();
}

MozImagePrefs.prototype = {

load : 
  function () {
    this.homeDir = this.prefs.getChar("mozimage.home_directory");
    this.autoSize = this.prefs.getBool("mozimage.autosize");
    this.slideshow = this.prefs.getBool("mozimage.slideshow");
    this.delay = this.prefs.getInt("mozimage.delay");
    this.zoom = this.prefs.getChar("mozimage.zoom");
    
    var extListStr = this.prefs.getChar("mozimage.extlist");
    if (extListStr == "")
      this.extList = new Array("jpg", "jpeg", "gif", "bmp", "png");
    else
      this.parseExtStr(extListStr);
      
    
    if (this.delay <= 0)
      this.delay = 2000;
    if (this.zoom <= 1)
      this.zoom = 1.5;
   
    if (this.homeDir == "")
    {
      var dirUtils = new DirUtils();
      this.homeDir = dirUtils.getCurProcDir();
    }
  },
  
parseExtStr :
  function (extListStr) {

    var ext = "";
    this.extList = new Array();

    for(var i = 0 ; i < extListStr.length ; i++)
    {
      if (extListStr[i] == ",")
      {
        this.extList.push(ext);
        ext = "";
      }
      else
        ext = ext + extListStr[i];
    }
    if (ext != "")
      this.extList.push(ext);
  },
  
save : 
  function () {
    this.prefs.setChar("mozimage.extlist", this.extList.toString()); 
    this.prefs.setChar("mozimage.home_directory", this.homeDir); 
    this.prefs.setBool("mozimage.autosize", this.autoSize); 
    this.prefs.setBool("mozimage.slideshow", this.slideshow); 
    this.prefs.setInt("mozimage.delay", this.delay); 
    this.prefs.setChar("mozimage.zoom", this.zoom); 
  },

getHomeDir : 
  function () { return(this.homeDir); },

setHomeDir : 
  function (aValue) { this.homeDir = aValue; },

getExtList : 
  function () {
   return(this.extList); 
  },

setExtList : 
  function (aValue) { this.extList = aValue; },

getAutoSize : 
  function () { return(Boolean(this.autoSize)); },

setAutoSize : 
  function (aValue) { this.autoSize = Boolean(aValue); },

getSlideshow : 
  function () { return(Boolean(this.slideshow)); },

setSlideshow : 
  function (aValue) { this.slideshow = Boolean(aValue); },

getDelay : 
  function () { return(Number(this.delay)); },

setDelay : 
  function (aValue) { this.delay = Number(aValue); },
  
getZoom : 
  function () { return(Number(this.zoom)); },

setZoom : 
  function (aValue) { this.zoom = Number(aValue); },
  
toggleExt :
  function (aExt) {
    var index = -1;
    for(var i = 0 ; i < this.extList.length ; i++)
    {
      if (this.extList[i] == aExt)
        index = i;
    }
    if (index != -1)
      this.extList.splice(index, 1);
    else
      this.extList.push(aExt);
  }

} // END CLASS

/*
**
** Predefined instance of the preferences class
** do not use any other instances
**
*/

var prefs = new MozImagePrefs();

/*
**
** Prefs window event handlers
**
*/

function prefs_load()
{
  var homedir = document.getElementById("homedir-text");
  var delay = document.getElementById("delay-text");
  var zoom = document.getElementById("zoom-text");
  prefs.load();
  var extList = prefs.getExtList();

  homedir.value = prefs.getHomeDir();
  delay.value = prefs.getDelay() / 1000;
  zoom.value = prefs.getZoom();
  for(var i = 0 ; i < extList.length ; i++)
  {
    var checkbox = document.getElementById(extList[i] + "-check");
    checkbox.checked = true;
  }
}

function prefs_close()
{
  var homedir = document.getElementById("homedir-text");
  var delay = document.getElementById("delay-text");
  var zoom = document.getElementById("zoom-text");
  prefs.setHomeDir(homedir.value);
  prefs.setDelay(delay.value * 1000);
  prefs.setZoom(zoom.value);
  prefs.save();
}

